unit fMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RpDefine, RpRave, StdCtrls, Buttons, RpBase, RpSystem;

type
  TfrmMain = class(TForm)
    BitBtn1: TBitBtn;
    RvProject1: TRvProject;
    RvSystem1: TRvSystem;
    procedure BitBtn1Click(Sender: TObject);
    procedure RvSystem1OverrideSetup(ReportSystem: TRvSystem;
      OverrideMode: TOverrideMode; var OverrideForm: TForm);
    procedure RvSystem1OverridePreview(ReportSystem: TRvSystem;
      OverrideMode: TOverrideMode; var OverrideForm: TForm);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses
  fReportPreView, fReportSetup;

{$R *.dfm}

procedure TfrmMain.BitBtn1Click(Sender: TObject);
begin
  RvProject1.Execute;
end;

procedure TfrmMain.RvSystem1OverrideSetup(ReportSystem: TRvSystem;
  OverrideMode: TOverrideMode; var OverrideForm: TForm);
begin
  case OverrideMode of
    omCreate:
      begin
        OverrideForm := TdtSetupForm.Create(nil);
        OverrideForm.Caption := RvSystem1.TitleSetup;
        (OverrideForm as TdtSetupForm).ReportSystem := ReportSystem;
      end;
    omShow:
      begin
        with OverrideForm as TdtSetupForm, ReportSystem do
        begin
          PreviewSetup := False;
          Aborted := ShowModal = mrCancel;
        end;
      end;
    omWait:
      begin
//	{because showModal: no wait necessary!)
      end;
    omFree:
      begin
        OverrideForm.Free;
      end;
  end;
end;

procedure TfrmMain.RvSystem1OverridePreview(ReportSystem: TRvSystem;
  OverrideMode: TOverrideMode; var OverrideForm: TForm);
begin
  Case OverrideMode Of
    omCreate: Begin
        OverrideForm := TfrmReportPreView.Create(self);
        OverrideForm.Caption := ReportSystem.TitlePreview;
        OverrideForm.Width := ReportSystem.SystemPreview.FormWidth;
        OverrideForm.Height := ReportSystem.SystemPreview.FormHeight;
        OverrideForm.WindowState := ReportSystem.SystemPreview.FormState;
        (OverrideForm As TfrmReportPreView).ReportSystem := ReportSystem;
      End;

    omShow: Begin
        ReportSystem.SystemPreview.InitPreview((OverrideForm As TfrmReportPreView).RvRenderPreview);
        If Assigned(ReportSystem.OnPreviewSetup) Then Begin
          ReportSystem.OnPreviewSetup((OverrideForm As TfrmReportPreView).RvRenderPreview);
        End; // if

        (OverrideForm As TfrmReportPreView).InputFileName := ReportSystem.SystemFiler.Filename;
        (OverrideForm As TfrmReportPreView).InputStream := ReportSystem.SystemFiler.Stream;
        (OverrideForm As TfrmReportPreView).InitFromRPSystem;
    (* *)
        If soPreviewModal In ReportSystem.SystemOptions Then Begin
          OverrideForm.ShowModal;
        End Else Begin
          OverrideForm.Show;
        End; // else
      End;

    omWait: Begin
        If Not (soPreviewModal In ReportSystem.SystemOptions) Then Begin
      // Wait for close
          Repeat
            Sleep(250);
            Application.ProcessMessages;
          Until Not OverrideForm.Visible;
        End; // if 
      End;
    omFree: Begin
        If (ReportSystem.SystemFiler.StreamMode In [smTempFile, smFile]) Then Begin
          (OverrideForm As TfrmReportPreView).RvRenderPreview.NDRStream.Free;
          (OverrideForm As TfrmReportPreView).RvRenderPreview.NDRStream := Nil;
        End; // if
        FreeAndNil(OverrideForm);
      End;
  End; // case
end;

end.
